Lucene++ - a full-featured, c++ search engine
API Documentation

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

Public Member Functions | Static Public Member Functions | Protected Member Functions
Lucene::PayloadFunction Class Referenceabstract

An abstract class that defines a way for Payload*Query instances to transform the cumulative effects of payload scores for a document. More...

`#include <PayloadFunction.h>`

Inheritance diagram for Lucene::PayloadFunction:

## Public Member Functions

virtual | ~PayloadFunction ()
virtual String | getClassName ()
boost::shared_ptr< PayloadFunction > | shared_from_this ()
virtual double | currentScore (int32_t docId, const String &field, int32_t start, int32_t end, int32_t numPayloadsSeen, double currentScore, double currentPayloadScore)=0
| Calculate the score up to this point for this doc and field. More...
virtual double | docScore (int32_t docId, const String &field, int32_t numPayloadsSeen, double payloadScore)=0
| Calculate the final score for all the payloads seen so far for this doc/field. More...
virtual int32_t | hashCode ()=0
| Return hash code for this object. More...
virtual bool | equals (const LuceneObjectPtr &other)=0
| Return whether two objects are equal. More...
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed. More...
virtual LuceneObjectPtr | clone (const LuceneObjectPtr &other=LuceneObjectPtr())
| Return clone of this object. More...
virtual int32_t | compareTo (const LuceneObjectPtr &other)
| Compare two objects. More...
virtual String | toString ()
| Returns a string representation of the object. More...
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock. More...
virtual LuceneSignalPtr | getSignal ()
| Return this object signal. More...
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout. More...
virtual void | unlock ()
| Unlock this object. More...
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread. More...
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout. More...
virtual void | notifyAll ()
| Notify all threads waiting for signal. More...

## Static Public Member Functions

static String | _getClassName ()

## Protected Member Functions

| PayloadFunction ()
Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()

## Additional Inherited Members

Protected Attributes inherited from Lucene::LuceneSync
SynchronizePtr | objectLock
LuceneSignalPtr | objectSignal

## Detailed Description

An abstract class that defines a way for Payload*Query instances to transform the cumulative effects of payload scores for a document.

See also
  PayloadTermQuery for more information

## Constructor & Destructor Documentation

Lucene::PayloadFunction::PayloadFunction | ( |  | ) |

protected

virtual Lucene::PayloadFunction::~PayloadFunction | ( |  | ) |

virtual

## Member Function Documentation

static String Lucene::PayloadFunction::_getClassName | ( |  | ) |

inline static

virtual double Lucene::PayloadFunction::currentScore | ( | int32_t | docId,
|  | const String & | field,
|  | int32_t | start,
|  | int32_t | end,
|  | int32_t | numPayloadsSeen,
|  | double | currentScore,
|  | double | currentPayloadScore
| ) |  |

pure virtual

Calculate the score up to this point for this doc and field.

Parameters

  docId | The current doc
  field | The field
  start | The start position of the matching Span
  end | The end position of the matching Span
  numPayloadsSeen | The number of payloads seen so far
  currentScore | The current score so far
  currentPayloadScore | The score for the current payload

Returns
  The new current Score

See also
  Spans

Implemented in Lucene::AveragePayloadFunction, Lucene::MaxPayloadFunction, and Lucene::MinPayloadFunction.

virtual double Lucene::PayloadFunction::docScore | ( | int32_t | docId,
|  | const String & | field,
|  | int32_t | numPayloadsSeen,
|  | double | payloadScore
| ) |  |

pure virtual

Calculate the final score for all the payloads seen so far for this doc/field.

Parameters

  docId | The current doc
  field | The current field
  numPayloadsSeen | The total number of payloads seen on this document
  payloadScore | The raw score for those payloads

Returns
  The final score for the payloads

Implemented in Lucene::AveragePayloadFunction, Lucene::MaxPayloadFunction, and Lucene::MinPayloadFunction.

virtual bool Lucene::PayloadFunction::equals | ( | const LuceneObjectPtr & | other | ) |

pure virtual

Return whether two objects are equal.

Reimplemented from Lucene::LuceneObject.

Implemented in Lucene::AveragePayloadFunction, Lucene::MaxPayloadFunction, and Lucene::MinPayloadFunction.

virtual String Lucene::PayloadFunction::getClassName | ( |  | ) |

inline virtual

Reimplemented in Lucene::AveragePayloadFunction, Lucene::MaxPayloadFunction, and Lucene::MinPayloadFunction.

virtual int32_t Lucene::PayloadFunction::hashCode | ( |  | ) |

pure virtual

Return hash code for this object.

Reimplemented from Lucene::LuceneObject.

Implemented in Lucene::AveragePayloadFunction, Lucene::MaxPayloadFunction, and Lucene::MinPayloadFunction.

boost::shared_ptr< PayloadFunction > Lucene::PayloadFunction::shared_from_this | ( |  | ) |

inline

The documentation for this class was generated from the following file:

- PayloadFunction.h

clucene.sourceforge.net